/*****************************************************************

  Copyright (c) 1999 - 2003 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#include <stdio.h>

#define NELEM(t) ((sizeof (t))/(sizeof(t[0])))

void zlog (const char* fmt, ...);	// pour la journalisation.

#define T_STRING	0
#define T_EOF		1
#define T_NUMBER	2
#define T_VOID		3

class Lexeme {
public:
	int		_type;		// type de token.
	char*	_string;	// valeur.

	Lexeme () {};
	Lexeme (int t, char* s) { _type = t, _string = s; }
};

struct Special {
	char	character;
	char	type;
};

class Lexer {
public:
	Special*	_splicing;		// caractres  retourner tels quels.
	const char**		_keywords;
	const char**		_err;
	int			_line_number;
	const char*		_filename;
	FILE*		_fp;
	Lexeme		_ringur;

			Lexer (const char* filename, const char** keywords, const char** err, Special* spec);
			~Lexer () { if (_fp != 0) fclose (_fp); }
	int		is_splicing (int c);
	void	unlex (Lexeme& l) { _ringur = l; }
	Lexeme	expect (int t, const char* msg =0);
	void	warning (const char* msg) {
		zlog ("%s:%d %s\n", _filename, _line_number, msg);
	}
	Lexeme	lex (void);
};
