/*****************************************************************

  Copyright (c) 1999 - 2003 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#ifndef SERVICE_H
#define SERVICE_H

#define NB_VERSIONS 3

enum TypeHrs {
	HEURE_STAT_A, HEURE_STAT_B,
	HEURE_COMP_A, HEURE_COMP_B,
	HEURE_COMP_EXT, HEURE_COMP_EXT_B,
	HEURE_STAT_EXT, HEURE_STAT_EXT_B,
	HEURE_GRAT, HEURE_GRAT_B
};

enum TypeEns {
//	Cours	TD	TP	MP	Demi-TD	Soutien TD	Soutien 2e Session	Cours/TD
	COURS,	TD,	TP,	MP,	DTD,	STD,		SSS,			COURS_TD,
};

#define N_ENS_TYPES	(COURS_TD-COURS)				// cours, td, tp, mp
#define N_HRS_TYPES	(HEURE_GRAT_B-HEURE_STAT_A+1)	// stat a, comp a, stat b, comp b, comp_ext, stat_ext, gratos

#include "Enseignement.h"	// doit tre aprs la dfinition de N_HRS_TYPES et de
							// N_ENS_TYPES pour pouvoir en profiter!

extern const char* _genre [N_ENS_TYPES+1];		// cours, td, tp, mp, cours/td

char*	AscTime (time_t* t);
time_t	MakeTime (int j, int m, int a);
time_t	String2Time (char* date);
int		Per2Time (char* periode, time_t& debut, time_t& fin);
int		Per2Semestre (char* periode);

enum Editable {
	NON_EDITABLE, EDIT_SERVICE, EDIT_MANDATEMENTS
};

class Service {
public:
	static char		_sep [4];				// sparateur de cours <==> nom dans un URL et id <==> passwd.
	static float	taux [N_ENS_TYPES+1];	// les taux de conversion en heure qTD.
	Enseignement*	_ens;		// enseignement effectu.
	float			_heures [N_HRS_TYPES][N_ENS_TYPES];
	time_t			_date;		// date de dernire modification.
	bool			_prioritaire [N_ENS_TYPES];	// enseignant prioritaire sur cet enseignement.
	bool			_prime;			// charge sous forme de prime ou d'heures de cours ?

public:
	Service () {};
	Service (Enseignement* ens);
	bool vide ();
	void affiche (Enseignant*, Editable, bool =false);
	void affiche_liste (char*, int);
	float affiche_stat (int th, char** filiere, char** intitule, float volume []);
	float affiche_service (int th, char** filiere, char** intitule, float volume []);
	float eq_td (int type, bool commun =false);
private:
	void affiche_aux (Enseignant*, int th, int i, Editable, bool, bool);
	void affiche_list_aux (char*, int, int);
};

/*
 *	Les mandatements
 */

enum Division {
	ORIENTATION, FORMATION, RECHERCHE, STAPS, FP
};

#define MAX_MAND	16

#define MAND_EQTD(m) \
	((m)-> _vol [COURS] * Service::taux [COURS] + \
	 (m)-> _vol [TD] * Service::taux [TD] + \
	 (m)-> _vol [TP] * Service::taux [TP] + \
	 (m)-> _vol [MP] * Service::taux [MP] + \
	 (m)-> _vol [DTD] * Service::taux [DTD] + \
	 (m)-> _vol [STD] * Service::taux [STD] + \
	 (m)-> _vol [SSS] * Service::taux [SSS])

class Mandatement {
public:
	static const char*	_nom_div [((int)FP)+1];
	static float	taux [MAX_MAND];	// les prix d'une heure de TD.
	time_t			_date;				// date de mandatement.
	bool			_fi;				// Initiale ou continue.
	Division		_division;			// qui paie.
	float			_vol [N_ENS_TYPES];	// volumes horaires (Cours, TD, TP, MP).
	float			_taux;				// taux horaire.
	time_t			_deb_periode;		// priode dans l'anne.
	time_t			_fin_periode;		// priode dans l'anne.
	Service*		_s;					// service qui est mandat.

public:
	float affiche (Enseignant*);
	float imprime (Enseignant*);
	void affiche_liste (int);
};

#endif
