/*****************************************************************

  Copyright (c) 1999 - 2003 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#include "Vector.h"

Vector::~Vector ()
{
	_content = 0;
}

void Vector::clean (void) {	// vide le vecteur.
#if 0
	if (_nslots > 0) {
		for (int i = 0; i < _length; ++i)
			delete _content [i];
		free (_content);
	}
#endif
	_content = 0;
	_nslots = 0;
	_length = 0;
}

void*& Vector::operator [] (int i)
{
	if (i >= _length) {
		if (i >= _nslots) {
			_nslots = i + 8;	// nouvelle taille.
			_content = (void**) realloc (_content, _nslots * sizeof (void*));
		}
		_length = i+1;			// ajuster la longueur. (tant pis pour [_length -> i])
	}
	return _content [i];
}

/*
 *	Retire 'len' lments  partir de la position 'pos'
 */

void Vector::remove (int pos, int len)
{
	if (len > _length - pos)
		len = _length - pos;	// tout le reste

	for (int i = pos+len; i < _length;)
		_content [pos++] = _content [i++];
	_length -= len;
}

/*
 *	Insre 'b'  la position 'pos' (si pos == _length, l'ajoute au bout).
 */

void Vector::insert (int pos, void* b)
{
	// se faire de la place et insrer b.
	if (_length >= _nslots) {
		_nslots = _length + 8;	// nouvelle taille.
		_content = (void**) realloc (_content, _nslots * sizeof (void*));
	}
	// Pousser le tout  droite d'un cran.
	// (si pos == _length, a ajoute au bout).
	for (int i = _length; --i >= pos;)
		_content [i+1] = _content [i];
	_content [pos] = b;
	++ _length;
}
