/*****************************************************************

  Copyright (c) 1999 - 2003 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#ifndef VECTOR_h
#define VECTOR_h

#include <stdlib.h>

class Vector {
private:
	void**	_content;	// le contenu.
	int		_nslots;	// nombre de cases alloues.
	int		_length;	// nombre de cases utilises.

public:
	Vector (int n =8) {
		_content = (n > 0 ) ? (void**) malloc (n * sizeof (void*)) : 0;
		_nslots = n;
		_length = 0;	// vecteur vide au dpart.
	}
	~Vector ();

	void clean (void);	// vide le vecteur.
	void insert (int, void*);
	void remove (int, int);
	void add (void* v) { insert (_length, v); }
	int length (void) { return _length; }
	void*& operator [] (int i);
};

#endif
