#include <stdio.h>
#include <string.h>
#include "display.h"

extern char* _outp_;

/*
 *	Affiche un beau titre au look Star Trek TNG.
 */

void TNG_arrow_title (char* prev, char* next, char* label, char* reste)
{
	static char	fmt1 [] =
		"<table width=100%% cellspacing=2 cellpadding=0 border=0>\n"
		"<tr>\n"
		"	<td width=20><img src=left-round-20x40.png></td>\n"
		"	<td bgcolor=\"%s\" align=center width=40><a title=prcdent href=\"%s\"><img src=left-arrow.png border=0></a></td>\n"
		"	<td bgcolor=\"%s\" align=center width=40><a title=suivant href=\"%s\"><img src=right-arrow.png border=0></a></td>\n";
	static char	fmt2 [] =
		"	<td align=center height=40 bgcolor=\"%s\"><font size=4 color=#000000 face=Helvetica>%s</font></td>\n";
	static char fmt3 [] =
		"	%s\n"
		"	<td width=20><img src=right-round-20x40.png></td>\n"
		"</tr>\n"
		"</table>\n";

	_outp_ += sprintf (_outp_, fmt1, page_colors [TitreNormal], prev,
									 page_colors [TitreNormal], next);
	if (label [0] != 0)
		_outp_ += sprintf (_outp_, fmt2, page_colors [TitreNormal], label);
	_outp_ += sprintf (_outp_, fmt3, reste);
}

void TNG_round_title_begin ()
{
	static char	fmt [] =
		"<table width=100%% cellspacing=2 cellpadding=0 border=0>\n"
		"<tr>\n"
		"	<td width=20><img src=left-round-20x40.png></td>\n";

	strcpy (_outp_, fmt);
	_outp_ += sizeof (fmt) - 1;
}

void TNG_round_title_end ()
{
	static char	fmt [] =
		"	<td width=20><img src=right-round-20x40.png></td>\n"
		"</tr>\n"
		"</table>\n";

	strcpy (_outp_, fmt);
	_outp_ += sizeof (fmt) - 1;
}

void TNG_title (char* label)
{
	static char	fmt [] =
		"<table width=100%% cellspacing=2 cellpadding=0 border=0>\n"
		"<tr>\n"
		"	<td width=20><img src=left-round-20x40.png></td>\n"
		"	<td align=center height=40 bgcolor=\"%s\">\n"
		"	<font size=5 color=#FFFF00 face=Helvetica>%s</font>\n"
		"	</td>\n"
		"	<td width=20><img src=right-round-20x40.png></td>\n"
		"</tr>\n"
		"</table>\n"
		"<p>\n";

	_outp_ += sprintf (_outp_, fmt, page_colors [TitreEmphase], label);
}

void TNG_top_table (int width, char* label)
{
	static char	fmt [] =
		"<table width=98%% cellspacing=0 cellpadding=0 border=0>\n"
		"<tr>\n"
		"	<td width=30><img src=top-left-violet-gauche.png></td>\n"
		"	<td width=%d height=41 bgcolor=\"%s\">&nbsp;</td>\n"
		"	<td width=25><img src=top-left-violet-droit.png></td>\n"
		"	<td colspan=6>\n"
		"		<table width=100%% cellspacing=0 cellpadding=0 border=0>\n"
		"		<tr>\n"
		"			<td align=center valign=center height=18 bgcolor=\"%s\">\n"
		"			<font size=3 face=Helvetica>%s</font>\n"
		"			</td>\n"
		"			<td width=1><img src=1x11.png></td>\n"
		"			<td width=11><img src=right-round-violet.png></td>\n"
		"		</tr>\n"
		"		<tr><td height=18><font size=1>&nbsp;</td></tr>\n"
		"		</table>\n"
		"	</td>\n"
		"</tr>\n"
		"</table>\n";

	_outp_ += sprintf (_outp_, fmt,
						1+width,
						page_colors [Liste], page_colors [Liste],
						label);
}

void TNG_mid_table (int width, int height, char* label)
{
	static char fmt [] =
		"<tr>\n"
		"	<td width=%d>\n"
		"		<table height=%d bgcolor=\"%s\" width=%d cellspacing=0 cellpadding=0 border=0>\n"
		"		<tr><td align=center>%s</td></tr>\n"
		"		</table>\n"
		"	</td>\n";

	_outp_ += sprintf (_outp_, fmt, 45+width, height,
									page_colors [Liste],
									37+width, label);
}

/*
 *	Affiche une liste au format Star Trek TNG.
 */

void TNG_top_list (int width, char* label, char* ovr, int spc)
{
	static char	fmt [] =
		"<table width=98%% cellspacing=0 cellpadding=0 border=0>\n"
		"<tr>\n"
		"	<td width=30><img src=top-left-violet-gauche.png></td>\n"
		"	<td width=%d height=40 bgcolor=\"%s\">&nbsp;</td>\n"
		"	<td width=25><img src=top-left-violet-droit.png></td>\n"
		"	<td colspan=6>\n"
		"		<table width=100%% cellspacing=0 cellpadding=0 border=0>\n"
		"		<tr>\n"
		"			<td align=center valign=top height=20 bgcolor=\"%s\">\n"
		"			<font size=3 face=Helvetica>%s</font>\n"
		"			</td>\n"
		"			<td width=1><img src=1x11.png></td>\n"
		"			<td width=11><img src=right-round-violet.png></td>\n"
		"		</tr>\n"
		"		<tr><td height=19><font size=1>&nbsp;</td></tr>\n"
		"		</table>\n"
		"	</td>\n"
		"</tr>\n"
		"</table>\n"
		"<table width=%s cellspacing=%d cellpadding=0 border=0>\n";

	_outp_ += sprintf (_outp_, fmt, 1+width,
								page_colors [Liste],
								page_colors [Liste],
								label, ovr, spc);
}

void TNG_mid1_list (int width, int height, char* label)
{
	static char fmt1 [] =
		"<tr>\n"
		"	<td width=%d>\n";
	static char fmt2 [] =
		"		<table height=%d bgcolor=\"%s\" width=%d cellspacing=0 cellpadding=0 border=0>\n"
		"		<tr>%s</tr>\n"
		"		</table>\n";
	static char fmt3 [] =
		"	</td>\n";

	_outp_ += sprintf (_outp_, fmt1, 45+width);
	// si height==0 le bord gauche est creux.
	if (height > 0)
		_outp_ += sprintf (_outp_, fmt2, height, page_colors [Liste], 37+width, label);

	strcpy (_outp_, fmt3);
	_outp_ += sizeof (fmt3) - 1;
}

void TNG_mid2_list ()
{
	static char fmt [] =
		"</td>\n"
		"	<td width=12></td>\n"
		"</tr>\n";

	strcpy (_outp_, fmt);
	_outp_ += sizeof (fmt) - 1;
}

void TNG_bot_list (int width, char* label)
{
	static char fmt [] =
		"</table>\n"
		"<table width=98%% cellspacing=0 cellpadding=0 border=0>\n"
		"<tr>\n"
		"	<td width=30><img src=bot-left-violet-gauche.png></td>\n"
		"	<td width=%d height=41 bgcolor=\"%s\">&nbsp;</td>\n"
		"	<td width=25><img src=bot-left-violet-droit.png></td>\n"
		"	<td colspan=6>\n"
		"		<table width=100%% cellspacing=0 cellpadding=0 border=0>\n"
		"		<tr><td height=19><font size=1>%s</td></tr>\n"
		"		<tr>\n"
		"			<td align=center height=22 bgcolor=\"%s\"></td>\n"
		"			<td width=1><img src=1x11.png></td>\n"
		"			<td width=11><img src=right-round-violet.png></td>\n"
		"		</tr>\n"
		"		</table>\n"
		"	</td>\n"
		"</tr>\n"
		"</table>\n";

	_outp_ += sprintf (_outp_, fmt,
				1+width,
				page_colors [Liste],
				label,
				page_colors [Liste]);
}
