/*****************************************************************

  Copyright (c) 1999 - 2012 by Patrick Amar - pa@lri.fr

    http://www.lri.fr/~pa

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

//#define ECHO_REQUESTS 1

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>
#include <signal.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/time.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>

#if ZLOG
#include <zlib.h>
#endif

#include "tcp_socket.h"

#include "Service.h"
#include "Enseignement.h"
#include "Enseignant.h"
#include "Commands.h"
#include "Security.h"
#include "display.h"

#define BUF_SIZE	3000*1024
#define CMD_SIZE	4096
#define AV_SIZE		512
#define SMALLBUFLEN	512			// taille d'un "petit" buffer.

static char		last_request [CMD_SIZE];	// dernire requte  avoir t analyse.

static int		ignored_retval = 0;		// faire taire g++  propos des valeurs de retour ignores.
static char*	ignored_retvalc = 0;	// faire taire g++  propos des valeurs de retour ignores.
static char		cur_dir [256];
static time_t	now = 1;
static char		header [] =
				"HTTP/1.1 200 Data Follows\n"
				"Date: %s"
				"Last-Modified: %s"
				"Cache-Control: no-cache\n"
				"Pragma: no-cache\n"
				"Server: Navajo 1.0\n"
				"Content-Length: %d\n"
				"Content-Type: %s; charset=ISO-8859-1\n"
				"ForceType: %s; charset=ISO-8859-1\n"
				"\n";

static char		header_cache [] =
				"HTTP/1.1 200 Data Follows\n"
				"Date: %s"
				"Last-Modified: %s"
				"Server: Navajo 1.0\n"
				"Content-Length: %d\n"
				"Content-Type: %s; charset=ISO-8859-1\n"
				"ForceType: %s; charset=ISO-8859-1\n"
				"\n";

char*	Host;		// pour le flicage.
char*	_outp_;		// pointeur du buffer de sortie.
char	CommandeInconnue [] = "<h3>Commande inconnue";

#if ZLOG
gzFile	log_fp = 0;
#endif

/*
 *	Traite les caractre bizarres.
 */

#define hex(c) (((c) <= '9') ? (c) - '0' : (c) + 10 - 'A')
static void process_charset (char* s, char* d)
{
	for (;;)
		switch ((unsigned char) (*d++ = *s++)) {
		// charset du mac:  = 0x8e  = 0x8f  = 0x90  = 0x88  = 0x89
		case 0x8e:
			d [-1] = '';
			continue;

		case 0x8f:
			d [-1] = '';
			continue;

		case 0x90:
			d [-1] = '';
			continue;

		case 0x88:
			d [-1] = '';
			continue;

		case 0x89:
			d [-1] = '';
			continue;

		case '+':
			d [-1] = ' ';
			continue;

		case '%':
			d [-1] = (hex (s [0]) * 16) + hex (s [1]);
			s += 2;
			continue;

		case 0:
			d [-1] = 0;
			return;
	}
}

//
//	Analyse un argument d'une commande.
//

static char** parse_arg (char* s)
{
	static char*	av [AV_SIZE];
	static char		tmp [CMD_SIZE];
	char*			p;
	int				ac = 0;

	p = tmp;
	av [ac++] = tmp;
	for (;;) switch ((unsigned char) (*p++ = *s++)) {
	// charset du mac:  = 0x8e  = 0x8f  = 0x90  = 0x88  = 0x89
		case 0x8e:
			p [-1] = '';
			continue;

		case 0x8f:
			p [-1] = '';
			continue;

		case 0x90:
			p [-1] = '';
			continue;

		case 0x88:
			p [-1] = '';
			continue;

		case 0x89:
			p [-1] = '';
			continue;

		case '+':
			p [-1] = ' ';
			continue;

		case '%':
			p [-1] = (hex (s [0]) * 16) + hex (s [1]);
			s += 2;
			continue;

		case '&':
			p [-1] = 0;
			av [ac++] = p;
			continue;

		case 0:
			av [ac] = 0;
			return av;
	}
}

#undef hex

/*
 *	Dcode le buffer cod en base64
 */

static short index_64 [128] = {
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63,
	52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1,
	-1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14,
	15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1,
	-1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
	41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -1, -1, -1, -1, -1
};

char* unbase64 (char* buffer)
{
	int			c1, c2, c3, c4;	// 4 caractres pour coder 3 octets.
	static char	decoded [1024];	// buffer de sortie.
	char*		dp = decoded;

#define char64(c)  (((c) < 0 || (c) > 127) ? -1 : index_64 [(c)])
#define new_char(c) do c = *buffer++; while (c != 0 && isspace (c))

	while ((c1 = *buffer++) != 0) {
		if (isspace (c1))
			continue;

		// lire les trois octets suivants.
		new_char (c2);
		new_char (c3);
		new_char (c4);
		// premature EOS
		if (c2 == 0 || c3 == 0 || c4 == 0)
			return 0;
		// syndrome de la fin de message cod en base64.
		if (c1 == '=' || c2 == '=')
			return decoded;

		c1 = char64 (c1);
		c2 = char64 (c2);
		*dp ++ = ((c1 << 2) | ((c2 & 0x30) >> 4));
		if (c3 == '=') {
			*dp = 0;
			return decoded;
		}
		c3 = char64 (c3);
		*dp++ = (((c2 & 0XF) << 4) | ((c3 & 0x3C) >> 2));
		if (c4 == '=') {
			*dp = 0;
			return decoded;
		}
		c4 = char64 (c4);
		*dp++ = (((c3 & 0x03) << 6) | c4);
	}
	*dp = 0;
	return decoded;
#undef char64
#undef new_char
}

/*
 *	Demande un user/passwd au client.
 */

void get_user_passwd (char* realm, FILE* sock)
{
	static char	auth_header [] =
				"HTTP/1.1 401\n"
				"WWW-Authenticate: Basic realm=\"%s\"\n"
				"\n";
	char		tmp [SMALLBUFLEN];

	ignored_retval = write (fileno (sock), tmp, sprintf (tmp, auth_header, realm));
	// le client refera la requte avec l'authentification,
}

/*
 *	Renvoie une rponse de type 'no_data'
 */

void no_data (FILE* sock)
{
	static char	no_data [] = "HTTP/1.1 204\n\n";

	ignored_retval = write (fileno (sock), no_data, sizeof (no_data) - 1);
}

/*
 *	Traduire les lettres accentues ISO en &eacute; etc.
 */

#ifdef AVEC_ACCENTS
static int accent_write (char* tp, char* buffer, int size)
{
	static const char* acc_iso = "";
	static const char* acc_html [] = {
		"&eacute;", "&egrave;", "&ecirc;", "&agrave;",
		"&ocirc;", "&ccedil;", "&icirc;", "&ucirc;",
		"&Eacute;", "&Egrave;", "&Ecirc;", "&Agrave;",
		"&Ocirc;", "&Ccedil;", "&Icirc;", "&Ucirc;"
	};
	char*	s = tp;
	int		i, j;

	for (i=j=0; i < size; ++i) {
		char*	p = index ((char*)acc_iso, buffer [i]);

		// lettre accentue?
		if (p == 0)
			continue;
		// crire le bloc prcdent.
		if (j < i) {
			bcopy (buffer+j, tp, i-j);
			tp += i-j;
		}
		j = i+1;
		// crire le codage HTML.
		int	idx = p - acc_iso;
		int	l = strlen (acc_html [idx]);

		bcopy (acc_html [idx], tp, l);
		tp += l;
	}
	// le dernier bloc.
	if (j < i) {
		bcopy (buffer+j, tp, i-j);
		tp += i-j;
	}
	return tp-s;
}
#endif

/*
 *	Renvoie une rponse au client, en utilisant _outp_
 */

static void http_send (char* buffer, FILE* sock, const char* type)
{
	char	asc_now [64];
	char	tmp [512];
	int		size = _outp_ - buffer;

	if (size <= 0)
		return;		// il n'y a rien  envoyer au client.

	now = time (0);
	strcpy (asc_now, ctime (&now));
	if (0 == strcmp ("text/html", type)) {
		// le header.
		sprintf (tmp, header, asc_now, asc_now, size, type, type);
		ignored_retval = write (fileno (sock), tmp, strlen (tmp));
		ignored_retval = write (fileno (sock), buffer, size);
	} else {
		sprintf (tmp, header, asc_now, asc_now, size, type, type);	// retourner le header.
		ignored_retval = write (fileno (sock), tmp, strlen (tmp));
		ignored_retval = write (fileno (sock), buffer, size);	// copier la rponse vers le client.
	}
}

//
//	Input name in name, current directory in cur_dir. Absolute pathname returned.
//

static char* abspath (const char* name)
{
	static char	buf [256];
	char*	dir = cur_dir;
	const char*	s;
	char*	d;
	char	lnm [1000];

	strcpy (lnm, name);
	d = buf;
	s = dir;
	name = lnm;

	while ((*d++ = *s++) != 0);
	d [-1] = '/';
	s = name;
	if (*s == '/')
		d = buf;
	while ((*d++ = *s++) != 0)
		;
	d [-1] = '/';
	d  [0] = 0;
	d = buf;
	s = buf;
	while (*s)
		if ((*d++ = *s++) == '/' && d > buf + 1) {
			char*	t = d - 2;

			switch (*t) {
			case '/': 	// found // in the name
				--d;
				break;
			case '.': 
				switch (*--t) {
				case '/': // found /./ in the name
					d -= 2;
					break;
				case '.': 
					if (*--t == '/') {	// found /../
						while (t > buf && *--t != '/');
						d = t + 1;
					}
					break;
				}
				break;
			}
		}
	if (*(d - 1) == '/' && d > buf+1)
		d--;
	*d = 0;
	return buf;
}

/*
 *	Traduit du postscript en pdf.
 */

static bool ps2pdf (char* buffer)
{
	// crire le fichier postscript.
	int	fd = creat ("tmp.ps", 0666);
	if (fd < 0)
		return false;

	ignored_retval = write (fd, buffer, _outp_ - buffer);
	close (fd);
	// le faire traduire par GhostScript.
	ignored_retval = system ("gs -sPAPERSIZE=a4 -q -dNOPAUSE -dBATCH -sDEVICE=pdfwrite -sOutputFile=tmp.pdf -c save pop -f tmp.ps");
	// lire le fichier pdf.
	fd = open ("tmp.pdf", 0);
	_outp_ = buffer + read (fd, buffer, BUF_SIZE-1);
	close (fd);
	return true;
}

/*
 *	Traduit du LaTeX en pdf.
 */

static bool pdflatex (char* buffer)
{
	// crire le fichier latex.
	int	fd = creat ("tmp.tex", 0666);
	if (fd < 0)
		return false;

	ignored_retval = write (fd, buffer, _outp_ - buffer);
	close (fd);
	// le faire traduire par pdflatex
	ignored_retval = system ("pdflatex EngagementHCC.tex > /dev/null 2>&1");
	// lire le fichier pdf.
	fd = open ("EngagementHCC.pdf", 0);
	_outp_ = buffer + read (fd, buffer, BUF_SIZE-1);
	close (fd);
	return true;
}

//
//	La commande GET
//

static void get_cmd (FILE* sock, char* url, char* buffer, char* user_passwd)
{
	enum { INVALIDE, HTML, IMAGE, TEXT }
				genre = INVALIDE;
	char*		file;
	char		asc_now [64];
	char		asc_mod [64];
	const char*		type = "text/plain";
	int			fd, size;
	struct stat	bufstat;

	file = url+1;
	url += strlen (url);
	// infrer le type  partir du nom d'url.
	if (!strcmp (url-5, ".html")) {
		type = "text/html";
		genre = HTML;
	}
	else if (!strcmp (url-4, ".ico")) {
		type = "image/icon";
		genre = IMAGE;
	}
	else if (!strcmp (url-4, ".gif")) {
		type = "image/gif";
		genre = IMAGE;
	}
	else if (!strcmp (url-4, ".png")) {
		type = "image/png";
		genre = IMAGE;
	}
	else if (!strcmp (url-4, ".jpg")) {
		type = "image/jpeg";
		genre = IMAGE;
	}
	else if (!strcmp (url-4, ".css")) {
		type = "text/css";
		genre = TEXT;
	}
	else if (!strcmp (url-4, ".pdf")) {
		type = "application/pdf";
		genre = IMAGE;
	}
#if FICHE_LATEX
	else if (!strcmp (url-4, ".lxf")) {
		_outp_ = buffer;			// pointer sur le buffer de rponse.
		url [-4] = 0;				// virer le suffixe.
		exec_get (* parse_arg (file), user_passwd, sock);	// excuter la requte.
		if (!strncmp (buffer, CommandeInconnue, sizeof (CommandeInconnue) - 1)) {
			http_send (buffer, sock, "text/html");	// renvoyer la rponse au client.
			return;
		}
		if (pdflatex (buffer))	// penser  passer 'file' en argument   pdflatex!
			http_send (buffer, sock, "application/pdf");
		else
			no_data (sock);
		return;
	}
#endif
	else if (!strcmp (url-4, ".pcf")) {
		_outp_ = buffer;			// pointer sur le buffer de rponse.
		url [-4] = 0;				// virer le .pdf qui ne sert plus!
		exec_get (* parse_arg (file), user_passwd, sock);	// excuter la requte.
		if (!strncmp (buffer, CommandeInconnue, sizeof (CommandeInconnue) - 1)) {
			http_send (buffer, sock, "text/html");	// renvoyer la rponse au client.
			return;
		}
		if (ps2pdf (buffer))
			http_send (buffer, sock, "application/pdf");
		else
			no_data (sock);
		return;
	}
	if (!strcmp (url-4, ".cp?")) {
		_outp_ = buffer;			// pointer sur le buffer de rponse.
		url [-4] = 0;				// virer le .cp? qui ne sert plus!
		exec_get (* parse_arg (file), user_passwd, sock);	// excuter la requte.
		if (!strncmp (buffer, CommandeInconnue, sizeof (CommandeInconnue) - 1))
			http_send (buffer, sock, "text/html");	// renvoyer la rponse au client.
		else
			http_send (buffer, sock, "application/postscript");
		return;
	}
	if (!strcmp (url-4, ".csv")) {
		_outp_ = buffer;			// pointer sur le buffer de rponse.
		url [-4] = 0;				// virer le .csv qui ne sert plus!
		exec_get (* parse_arg (file), user_passwd, sock);	// excuter la requte.
		http_send (buffer, sock, "text/plain");	// renvoyer la rponse au client.
		return;
	}
	if (!strcmp (url-4, ".cmd")) {
		_outp_ = buffer;			// pointer sur le buffer de rponse.
		url [-4] = 0;				// virer le .cmd qui ne sert plus!
		exec_get (* parse_arg (file), user_passwd, sock);	// excuter la requte.
		http_send (buffer, sock, "text/html");	// renvoyer la rponse au client.
		return;
	}
	// vrifier si le fichier est bien du bon genre et se trouve dans l'arborescence dsire.
	if (genre == INVALIDE || bcmp (abspath (file), cur_dir, strlen (cur_dir))) {
		now = time (0);
		// afficher le coupable.
		zlog ("Tsst tsst ??? %s: '%s' => %s", Host, file, ctime (&now));
		// dire qu'il n'y a pas de rponse.
		no_data (sock);
		return;
	}
	// retourner le fichier demand par le client.
	char	tmp [256];
	fd = open (file, 0);
	// faire un essai avec le nom 'arrang'.
	if (-1 == fd) {
		process_charset (file, tmp);
		file = tmp;
		fd = open (file, 0);
	}
	if (-1 == fd) {
		perror (file);
		// dire qu'il n'y a pas de rponse.
		no_data (sock);
		return;
	}
	fstat (fd, &bufstat);
	size = bufstat.st_size;

	now = time (0);
	strcpy (asc_now, ctime (&now));
	strcpy (asc_mod, ctime (&bufstat.st_mtime));
	if (genre == HTML) {
		char	tmp [512];

		// a DOIT tenir en 1 read!
		size = read (fd, buffer, BUF_SIZE);
#ifdef AVEC_ACCENTS
		char*	p = buffer+size;
		size = accent_write (p, buffer, size);
#endif
		sprintf (tmp, header_cache, asc_now, asc_mod, size, type, type);
		ignored_retval = write (fileno (sock), tmp, strlen (tmp));
#ifdef AVEC_ACCENTS
		ignored_retval = write (fileno (sock), p, size);
#else
		ignored_retval = write (fileno (sock), buffer, size);
#endif
	} else {
		// retourner le header. (dire de cacher le fichier)
		sprintf (buffer, header_cache, asc_now, asc_mod, size, type, type);
		ignored_retval = write (fileno (sock), buffer, strlen (buffer));
		// copier la rponse vers le client.
		while ((size = read (fd, buffer, BUF_SIZE)) > 0)
			ignored_retval = write (fileno (sock), buffer, size);
	}
	close (fd);
}

/*
 *	La commande de transfert de fichier (POST)
 */

static void file_transfer_cmd (FILE* sock, char* cmd, char* buffer, int length,
							   char* boundary, int boundary_length, char* user_passwd)
{
	static char*	av [AV_SIZE];
	static char		tmp [CMD_SIZE];
	int				ac;
	char			line [CMD_SIZE];
	char*			p;
	int				i;
	char*			file_buffer = 0;
	int				fi = 0;
	char			name [SMALLBUFLEN];
	char			filename [SMALLBUFLEN];
	char			tc [SMALLBUFLEN];
	char			type [64];
	int				cdisp = 0;
	bool			stop_on_boundary = false;	// manger les octets restant.

	ac = 1;			// pour singer parse_arg.
	p = tmp;
	av [0] = tmp;

	while (length > 0) {
		// lire une ligne (doit re le dlimiteur).
		for (i = 0; --length, '\n' != (line [i] = getc (sock)); ++i)
#if ECHO_REQUESTS
			putc (line [i], stderr)
#endif
			;
#if ECHO_REQUESTS
		putc ('\n', stderr);
#endif
		line [i-1] = 0;		// virer les \r\n
		if (0 != strncmp (line, boundary, boundary_length)) {
			zlog ("Dlimiteur manquant...\n");
			continue;
		}
		// transfert termin.
		if (line [boundary_length] == '-' && line [boundary_length+1] == '-') {
			if (stop_on_boundary)
				length = 2;
			while (--length >= 0)
#if ECHO_REQUESTS
				putc (getc (sock), stderr);
#else
				(void) getc (sock);
#endif
			break;
		}
		// lire ligne  ligne les indications jusqu' une ligne vide.
	suite:
		name [0] = 0;
		filename [0] = 0;
		type [0] = 0;
		for (;;) {
			for (i = 0; --length, '\n' != (line [i] = getc (sock)); ++i)
#if ECHO_REQUESTS
				putc (line [i], stderr)
#endif
				;
#if ECHO_REQUESTS
			putc ('\n', stderr);
#endif
			if (line [0] == '\r')
				break;

			line [i-1] = 0;	// virer les \r\n
			// couper la ligne en deux: avant et aprs les deux points.
			char* p = index (line, ':');
			if (p == 0)
				continue;	// bizarre !
			*p++ = 0;		// line: premier bout, p: deuxime bout.
			// mettre le tag en minuscules.
			for (i = 0; line [i] != 0; ++i)
				if ('A' <= line [i] && line [i] <= 'Z')
					line [i] += 'a' - 'A';
			// doit tre du genre Content-Disposition: form-data; bla bla
			if (!strcmp (line, "content-disposition")) {
				char	fmt [] = " form-data; name=\"";
				char	fmt_fich [] = "; filename=\"";

				cdisp = 0;
				if (0 != strncmp (p, fmt, sizeof (fmt) - 1))
				{
					zlog ("content-disposition: bizarre...\n");
					continue;
				}
				// rcuprer le nom.
				p += sizeof (fmt) - 1;
				for (i = 0; (name [i++] = *p++) != '\"';)
					;
				name [i-1] = 0;
				++ cdisp;	// on a au moins un nom.
				// y a-t-il une suite?
				if (0 != strncmp (fmt_fich, p, sizeof (fmt_fich) - 1))
					continue;

				// oui: rcuprer le nom du fichier.
				p += sizeof (fmt_fich) - 1;
				for (i = 0; (filename [i++] = *p++) != '\"';)
					;
				filename [i-1] = 0;
				++ cdisp;	// on a au moins un nom et un nom de fichier.
				continue;
			} else
			if (!strcmp (line, "content-type")) {
				if (1 != sscanf (p, " %s", type))
					zlog ("content-type: bizarre...\n");
				continue;
			}
		}
		// c'est la fin des indications, traiter chaque morceau.
		switch (cdisp) {
			case 1:
				for (i = 0; --length, '\n' != (line [i] = getc (sock)); ++i)
#if ECHO_REQUESTS
					putc (line [i], stderr)
#endif
					;
#if ECHO_REQUESTS
				putc ('\n', stderr);
#endif
				line [i-1] = 0;
				process_charset (line, tc);		// traiter les caractres bizarres.
				p += sprintf (p, "%s=%s", name, tc) + 1;
				av [ac++] = p;
				continue;

			case 2:
				// si on a un nom mais pas de nom de ficher c'est que a craint
				// il vaudra mieux ne pas croire le content-length et s'arreter au dlimiteur.
				stop_on_boundary = (name [0] != 0 && type [0] == 0);
				// accumuler les arguments.
				process_charset (filename, tc);		// traiter les caractres bizarres.
				p += sprintf (p, "%s=%s", name, tc) + 1;
				av [ac++] = p;
				p += sprintf (p, "T=%s", type) + 1;
				av [ac++] = p;
				file_buffer = (char*) malloc (length);
				fi = 0;
				while (length > 0) {
					// chercher un dlimiteur.
					for (i = 0; i < boundary_length; ++i) {
						line [i] = getc (sock); --length;
#if ECHO_REQUESTS
						putc (line [i], stderr);
#endif
						if (line [i] != boundary [i])
							break;
					}
					// trouv?
					if (i < boundary_length) {
						// non: on est dans le fichier.
						for (int k = 0; k <= i; ++k)
							file_buffer [fi++] = line [k];
						continue;
					}
					fi -= 2;	// on a lu \r\n en trop.
					file_buffer = (char*) realloc (file_buffer, fi);
					// oui, on a le dlimiteur.
					line [0] = getc (sock); --length;
					line [1] = getc (sock); --length;
#if ECHO_REQUESTS
					putc (line [0], stderr);
					putc (line [1], stderr);
#endif
					// est-ce la fin?
					if (line [0] == '-' && line [1] == '-') {
						if (stop_on_boundary) {
							length = 2;
							// en fait il n'y a pas de fichier !
							free (file_buffer);
							file_buffer = 0;
							fi = 0;
						}
						while (--length >= 0)
#if ECHO_REQUESTS
							putc (getc (sock), stderr);
#else
							(void) getc (sock);
#endif
						break;
					}
					// en fait, on a lu les \r\n donc on est prts  revoir un 'content-disposition'
					goto suite;
				}
				break;
		}
		break;
	}
	av [ac-1] = 0;	// terminer les arguments.
	// traiter la requte.
	_outp_ = buffer;
	exec_post_transfer (cmd, av, file_buffer, fi, user_passwd, sock);
	http_send (buffer, sock, "text/html");	// renvoyer la rponse au client.
}

#if 333
static int search (const char* pat, const char* txt)
{
	int	pat_len = strlen (pat);
	int	txt_len = strlen (txt);

	for (int i = 0; i <= txt_len-pat_len; ++i)
		if (0 == strncmp (pat, txt+i, pat_len))
			return i;
	return -1;
}
#endif

/*
 *	Analye la requte du client.
 */

char	_buffer_ [BUF_SIZE];

static void analyse (FILE* sock)
{
	bool	file_transfer = false;
	char	cmd [CMD_SIZE];
	char	line [CMD_SIZE];
	char	boundary [CMD_SIZE];
	int		boundary_length = 0;
	char	auth [SMALLBUFLEN];
	char*	user_passwd;
	int		n;
	int		i;

	auth [0] = 0;
	user_passwd = auth;
	// lire la commande.
	ignored_retvalc = fgets (line, sizeof line, sock);
	// la copier dans un buffer statique pour debug.
	strcpy (last_request, line);
#if ECHO_REQUESTS
	zlog ("%s", line);
#endif
	n = strlen (line);
	// index du dernier caractre.
	do --n; while (line [n] == '\n' || line [n] == '\r');
	// HEAD ?
	if (!strncmp ("HEAD ", line, 5)) {
		zlog ("%s", line);
		// on n'a rien compris: dire qu'il n'y a pas de rponse.
		no_data (sock);
		return;
	}
	// GET ?
	if (!strncmp ("GET ", line, 4) &&
		!strncmp (" HTTP/1.", line + n - 8, 8) &&
		(line [n] == '0' || line [n] == '1'))
	{
		// sparer la commande de la sauce (la commande peut avoir des espaces).
		for (i = 4; i < n-8; ++i)
			cmd [i-4] = line [i];
		cmd [i-4] = 0;
		// chercher l'autorisation et la fin de requte.
#if 333
		bool ignore = false;
#endif
		do {
			ignored_retvalc = fgets (line, sizeof line, sock);

			if (1 == sscanf (line, "Authorization: Basic %s", _buffer_)) {
				strcpy (auth, _buffer_);
				continue;
			}
#if ECHO_REQUESTS
			zlog ("%s", line);
#endif
#if 333
			if (1 == sscanf (line, "User-Agent: %[^\n]", _buffer_)) {
				if (0 <= search ("YandexBot", _buffer_))
					ignore = true;
				else if (0 <= search ("Googlebot", _buffer_))
					ignore = true;
			}
			else if (1 == sscanf (line, "X-Forwarded-For: %[^\n]", _buffer_)) {
				unsigned char	v [8];
				unsigned int	ip [4];

				zlog ("\t%s", _buffer_);
				if (4 == sscanf (_buffer_, "%u.%u.%u.%u", ip, ip+1, ip+2, ip+3)) {
					v [0] = (unsigned char) ip [0];
					v [1] = (unsigned char) ip [1];
					v [2] = (unsigned char) ip [2];
					v [3] = (unsigned char) ip [3];
					if (Security::banned (v))
						ignore = true;
					zlog ("\n");
				}
			}
#endif
		} while (line [0] != '\r');
		// tester l'accs.
#if 333
		if (!ignore)
#endif
		{
			user_passwd = (auth [0] != 0) ? unbase64 (auth) : auth;
			get_cmd (sock, cmd [1] == 0 ? (char*) "/index.html" : cmd, _buffer_, user_passwd);
		}
		return;
	}
	// POST.
	if (1 == sscanf (line, "POST %s HTTP/1.", cmd)) {
		// rcuprer les champs intressants.
		while (line [0] != '\r') {
			ignored_retvalc = fgets (line, sizeof line, sock);
			// ne pas sortir le mot de passe!!
#if ECHO_REQUESTS
			char tmp_buf [4096];
			if (1 != sscanf (line, "Authorization: Basic %s", tmp_buf))
				zlog ("%s", line);
#endif
			// couper la ligne en deux: avant et aprs les deux points.
			char* p = index (line, ':');
			if (p == 0)
				continue;	// bizarre !
			*p++ = 0;		// line: premier bout, p: deuxime bout.
			// tout mettre en minuscules.
			for (int i = 0; line [i] != 0; ++i)
				if ('A' <= line [i] && line [i] <= 'Z')
					line [i] += 'a' - 'A';
			// longueur du message.
			if (!strcmp (line, "content-length"))
				n = atoi (p);
			// type du message.
			else if (0 == strcmp (line, "content-type") &&
					 1 == sscanf (p, " multipart/form-data; boundary=%s", boundary+2))
			{
				file_transfer = true;
				boundary [0] = '-';
				boundary [1] = '-';
				boundary_length = strlen (boundary);
			}
			// identification.
			else if (0 == strcmp (line, "authorization")) {
				if (1 == sscanf (p, " Basic %s", auth))
					user_passwd = unbase64 (auth);
			}
		}
		// transfer de fichier.
		if (file_transfer) {
			file_transfer_cmd (sock, cmd+1, _buffer_, n, boundary, boundary_length, user_passwd);
			return;
		}
		// rcuprer les arguments.
		for (i = 0; i < n; ++i)
			line [i] = getc (sock);
		line [i] = 0;
#if ECHO_REQUESTS
		zlog ("%s\n", line);
#endif
		// traiter la requte.
		_outp_ = _buffer_;
		const char* mime_type = exec_post (cmd+1, parse_arg (line), user_passwd, sock);
		http_send (_buffer_, sock, mime_type);	// renvoyer la rponse au client.
		return;
	}
	/* on n'a rien compris: dire qu'il n'y a pas de rponse. */
	no_data (sock);
}

/*
 *	Rle  propos des options
 */

static void usage (char* progname)
{
	fprintf (stderr, "Usage: %s "
					 "[-c crash_cnt] "
					 "[-p port] "
					 "[-l log/-] "
					 "[-f filiere] "
					 "[-e profs perso] "
					 "[-s services]\n", progname);
	exit (1);
}

/*
 *	Rcupre les sigpipes.
 */

static jmp_buf	jbuf;

static void trap_sig (int)
{
	(void) signal (SIGPIPE, trap_sig);
	zlog ("SIGPIPE ??\n");
	longjmp (jbuf, 1);
}

/*
 *	Relance le serveur.
 */

static char*		_argv_ [32];	// sauvegarde des choix de lancement.
static tcp_socket*	tcp_sock;

void restart (void)
{
	char*	argv [32];
	char	tmp [256];

	delete tcp_sock;
	sleep (1);
	// fermer les fichers / sockets.
	for (int fd = 10; --fd > 2;)
		(void) close (fd);
	// rcuprer les arguments de lancement.
	FILE*	fp = fopen ("pid", "r");
	if (fp != 0) {
		int	n;

		ignored_retval = fscanf (fp, "%s\n", tmp);	// sauter le pid.
		for (n = 0; 1 == fscanf (fp, "%s\n", tmp); ++n)
			argv [n] = strdup (tmp);
		argv [n] = 0;
		fclose (fp);
		::execvp (argv [0], argv);
	}
	// se relancer.
	::execvp (_argv_ [0], _argv_);
}

/*
 *	Terminer en beaut
 */

static void trap_int (int signo)
{
	(void) signal (signo, trap_int);			// ractiver le handler du signal.
#if ZLOG
	extern gzFile	log_fp;

	if (log_fp != 0)
		gzflush (log_fp, Z_FINISH);
#endif
	::exit (0);
}


/*
 *	Se rcupre en cas de crash.
 */

const char*	__services = "services.sav";	// fichier de sauvegarde des services

static void trap_segv (int signo)
{
	static int	cnt = 0;		// nombre de crashes...
	char		tc [64];

	sprintf (tc, "%s.%d", __services, ++cnt);	// services.sav.N
	rename (__services, tc);					// mv services.save services.sav.N
	zlog ("Server crash: mv %s %s\n", __services, tc);
	zlog ("last_request: '%s'\n", last_request);
	auto_save (true, __services);				// refaire services.sav
#if ZLOG
	extern gzFile	log_fp;

	if (log_fp != 0)
		gzflush (log_fp, Z_FINISH);
#endif
	// limiter les essais  4.
	if (cnt == 4) {
		zlog ("self-restarting server after crash...\n");
		restart ();		// relancer le serveur.
		zlog ("restart failed, exiting...\n");
#if ZLOG
		if (log_fp != 0)
			gzflush (log_fp, Z_FINISH);
#endif
		::exit (1);
		return;		// not reached.
	}
	(void) signal (signo, trap_segv);			// ractiver le handler du signal.
}

/*
 *	Point d'entre.
 */

int main (int argc, char** argv)
{
	static char		__version [] = "3.2";
	extern void		load_service (const char*);	// import de Commands.cc
	int				fd;
	FILE*			fp = 0;
	unsigned char*	v;
	char*			argv0;
	int				port = 2008;			// numro de port par dfaut.
#if ZLOG
	const char*			log = "log.gz";				// fichier de messages par dfaut.
#else
	const char*			log = "log";				// fichier de messages par dfaut.
#endif
	const char*			profs = "profs.def";		// descriptif des enseignants et employeurs.
	const char*			perso = "perso.def";		// descriptif des infos personnelles.
	const char*			filieres = "filieres.def";	// descriptif des filires.

	/*
	 *	Sauver les choix de lancement pour un ventuel 'reload'
	 */
	for (int n = 0; n < argc; ++n)
		_argv_ [n] = strdup (argv [n]);
	_argv_ [argc] = 0;

	argv0 = argv [0];	// sauver le nom du serveur.
	for (++argv; *argv != 0; ++argv) {
		if (!strcmp (*argv, "-p")) {	// numro de port.
			if (*++argv != 0) {
				port = atoi (*argv);
				continue;
			}
			usage (argv0);
		}
		if (!strcmp (*argv, "-e")) {	// fichier des enseignants.
			if (*++argv != 0 && argv [1] != 0) {
				profs = *argv;
				perso = *++argv;	// les infos personnelles.
				continue;
			}
			usage (argv0);
		}
		if (!strcmp (*argv, "-f")) {		// fichier des filires.
			if (*++argv != 0) {
				filieres = *argv;
				continue;
			}
			usage (argv0);
		}
		if (!strcmp (*argv, "-s")) {	// fichier des services.
			if (*++argv != 0) {
				__services = *argv;
				continue;
			}
			usage (argv0);
		}
		if (!strcmp (*argv, "-w")) {		// ouvert en criture.
			Enseignant::_edit_mode = true;
			continue;
		}
		if (!strcmp (*argv, "-l")) {		// fichier de log.
			if (*++argv != 0) {
				log = *argv;
				if (log [0] == '-' && log [1] == 0)
					log = 0;	// stderr.
				continue;
			}
			usage (argv0);
		}
	usage (argv0);
	}
	// aller dans le directory de travail.
	if (getcwd (cur_dir, sizeof cur_dir) == 0) {
		zlog ("Cannot get the current directory name, giving up.\n");
		exit (1);
	}
	// ouvrir la connexion.
	tcp_sock = new tcp_socket (port, 10);
	if (!tcp_sock -> ok ()) {
		perror ("tcp_socket");
		exit (3);
	}
	// charger la configuration.
	Employeur::init (profs);	// les enseignants et employeurs.
								// (doit tre avant les enseignements)
	Perso::init (perso);		// les infos personnelles sur les enseignants.
								// (doit tre aprs les enseignants)
	Filiere::init (filieres);	// les enseignements.
	load_service (__services);	// les services.
	Security::init ("sites.acl");	// les listes d'accs.
	// annoncer la couleur.
	fprintf (stderr,
		"  VoeuX version %s, Copyright (C) 1999 - 2017 by Patrick Amar (pa@lri.fr)\n"
		"  VoeuX comes with ABSOLUTELY NO WARRANTY.\n"
		"  This is free software, and you are welcome to redistribute it\n"
		"  under certain conditions; for details see the General Public License.\n\n",
		__version);
	// rediriger la sortie d'erreurs sur le fichier de log.
	if (log != 0)
#if ZLOG
		if (0 == (log_fp = gzopen (log, "a"))) {
			printf ("Cannot open the log file: %s\n", abspath (log));
			log = 0;	// back to stderr.
		}
#else
		if (0 == freopen (log, "a", stderr)) {
			printf ("Cannot open the log file: %s\n", abspath (log));
			exit (2);
		}
	setlinebuf (stderr);	// affichage ligne par ligne dans le fichier de log.
#endif
	// dire qui on est dans le fichier pid.
	fp = fopen ("pid", "w");
	if (fp == 0) {
		perror ("pid");
		exit (4);
	}
	fprintf (fp, "%d\n", getpid ());
	// sauver les arguments de lancement.
	for (int n = 0; n < argc; ++n)
		fprintf (fp, "%s\n", _argv_ [n]);
	fclose (fp);
	fp = 0;
	// trappe les signaux.
	(void) signal (SIGSEGV, trap_segv);
	(void) signal (SIGBUS, trap_segv);
	(void) signal (SIGPIPE, trap_sig);
	(void) signal (SIGINT, trap_int);
	(void) signal (SIGTERM, trap_int);

	if (setjmp (jbuf) != 0) {
		if (fp != 0)
			fclose (fp);
	}

	for (;;) {
		fd_set	rfds;
		struct	timeval tv;
		int		retval;

		fd = tcp_sock -> accept ();
		if (fd < 0) {
			perror ("Error 'accept'...");
			continue;
		}
		if ((Host = tcp_sock -> where (fd, &v)) != 0) {
			if (Security::banned (v)) {
				close (fd);
				continue;
			}
		}
		// jeter le petits malins qui voudraient nous bloquer.
		FD_ZERO(&rfds);
		FD_SET(fd, &rfds);
		// attendre 5 secondes max.
		tv.tv_sec = 5;
		tv.tv_usec = 0;

		retval = select (fd+1, &rfds, 0, 0, &tv);
		if (retval == 0) {
			close (fd);
			continue;
		}
		// traiter la requte.
		fp = fdopen (fd, "r");
		analyse (fp);
		(void) fclose (fp);
		fp = 0;
	}
	return 0;
}
