/*
(c) Stephane Conversy
Laboratoire de Recherche en Informatique
Universite de Paris-Sud
Orsay, France

mailto:conversy@lri.fr
http://www-ihm.lri.fr/~conversy

Rduit aux socket serveur [pa@lri.fr] 1999.
*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>

#include "tcp_socket.h"

tcp_socket::tcp_socket (int port, int maxconn)
{
	int					optval = 1;
	struct sockaddr_in	sock;

	_sd = socket (AF_INET,SOCK_STREAM, 0);
	if (_sd == -1)
		return;		// faillu !

	(void)setsockopt (_sd, SOL_SOCKET, SO_REUSEADDR, (char*) &optval, sizeof(int));
	memset (&sock, 0, sizeof (sock));
	sock.sin_port = htons ((unsigned short) (port & 0xFFFF));
	sock.sin_family = AF_INET;
	sock.sin_addr.s_addr = INADDR_ANY;
	if (bind (_sd, (struct sockaddr*) (&sock), sizeof (struct sockaddr)) != 0 ||
		listen (_sd, maxconn) != 0)
	{
		(void) close (_sd);
		_sd = -1;
	}
}

char* tcp_socket::where (int fd, unsigned char** v)
{
	static char					result [256];
	static struct sockaddr_in	addr;	// doit rsister au retour de la fonction.
	struct hostent*				h;
	socklen_t					lenaddr = sizeof (addr);

	if (getpeername (fd,(struct sockaddr *)&addr, &lenaddr) == -1)
		return 0 ;

	*v = (unsigned char *)&addr.sin_addr.s_addr ;
	if ((h = gethostbyaddr ((char *)&addr.sin_addr, sizeof (addr.sin_addr), AF_INET)))
		sprintf (result, "%d.%d.%d.%d %s", (*v)[0], (*v)[1], (*v)[2], (*v)[3], h -> h_name);
	else
		sprintf (result, "%d.%d.%d.%d", (*v)[0], (*v)[1], (*v)[2], (*v)[3]);
	return result;
}

int tcp_socket::accept (void)
{
	struct sockaddr_in	addr;
	socklen_t			lenaddr = sizeof(addr);

	return ::accept (_sd, (struct sockaddr*) (&addr), &lenaddr);
}
